/** @file cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.23
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt */

#ifndef CMDLINE_H
#define CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE PACKAGE
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#ifdef PACKAGE_NAME
#define CMDLINE_PARSER_PACKAGE_NAME PACKAGE_NAME
#else
#define CMDLINE_PARSER_PACKAGE_NAME PACKAGE
#endif
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION VERSION
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *full_help_help; /**< @brief Print help, including hidden options, and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int hidden_flag;	/**< @brief treat dot files normally (default=off).  */
  const char *hidden_help; /**< @brief treat dot files normally help description.  */
  int makedirs_flag;	/**< @brief create non-existent directories (default=off).  */
  const char *makedirs_help; /**< @brief create non-existent directories help description.  */
  const char *move_help; /**< @brief move source file to target name help description.  */
  const char *copydel_help; /**< @brief copy source to target, then delete source help description.  */
  const char *rename_help; /**< @brief rename source to target in same directory help description.  */
  const char *copy_help; /**< @brief copy source to target, preserving source permissions help description.  */
  const char *overwrite_help; /**< @brief overwrite target with source, preserving target permissions help description.  */
  const char *append_help; /**< @brief append contents of source file to target help description.  */
  const char *hardlink_help; /**< @brief link target name to source file help description.  */
  const char *symlink_help; /**< @brief symlink target name to source file help description.  */
  const char *force_help; /**< @brief perform file deletes and overwrites without confirmation help description.  */
  const char *protect_help; /**< @brief treat file deletes and overwrites as errors help description.  */
  const char *go_help; /**< @brief skip any erroneous actions help description.  */
  const char *terminate_help; /**< @brief erroneous actions are treated as errors help description.  */
  const char *verbose_help; /**< @brief report all actions performed help description.  */
  const char *dryrun_help; /**< @brief only report which actions would be performed help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int full_help_given ;	/**< @brief Whether full-help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int hidden_given ;	/**< @brief Whether hidden was given.  */
  unsigned int makedirs_given ;	/**< @brief Whether makedirs was given.  */
  unsigned int move_given ;	/**< @brief Whether move was given.  */
  unsigned int copydel_given ;	/**< @brief Whether copydel was given.  */
  unsigned int rename_given ;	/**< @brief Whether rename was given.  */
  unsigned int copy_given ;	/**< @brief Whether copy was given.  */
  unsigned int overwrite_given ;	/**< @brief Whether overwrite was given.  */
  unsigned int append_given ;	/**< @brief Whether append was given.  */
  unsigned int hardlink_given ;	/**< @brief Whether hardlink was given.  */
  unsigned int symlink_given ;	/**< @brief Whether symlink was given.  */
  unsigned int force_given ;	/**< @brief Whether force was given.  */
  unsigned int protect_given ;	/**< @brief Whether protect was given.  */
  unsigned int go_given ;	/**< @brief Whether go was given.  */
  unsigned int terminate_given ;	/**< @brief Whether terminate was given.  */
  unsigned int verbose_given ;	/**< @brief Whether verbose was given.  */
  unsigned int dryrun_given ;	/**< @brief Whether dryrun was given.  */

  char **inputs ; /**< @brief unnamed options (options without names) */
  unsigned inputs_num ; /**< @brief unnamed options number */
  int delete_group_counter; /**< @brief Counter for group delete */
  int erroneous_group_counter; /**< @brief Counter for group erroneous */
  int mode_group_counter; /**< @brief Counter for group mode */
  int report_group_counter; /**< @brief Counter for group report */
} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief the description string of the program */
extern const char *gengetopt_args_info_description;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];
/** @brief all the lines making the full help output (including hidden options) */
extern const char *gengetopt_args_info_full_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the full help (including hidden options)
 */
void cmdline_parser_print_full_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CMDLINE_H */
